package com.example.pruebamaps.Menu

import android.icu.util.TimeUnit
import okhttp3.OkHttpClient
import okhttp3.logging.HttpLoggingInterceptor
import retrofit2.Call
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import retrofit2.http.GET
import retrofit2.http.Path
import retrofit2.http.Query
import javax.xml.datatype.DatatypeConstants.MINUTES

interface MarcadorApi {


    @GET("?in_bbox")
    fun getMarker(
        @Query("limit") limit : Int,
        @Query("offset") offset : Int
    ): Call<Coordenadas>


        companion object {

            val stackClient by lazy { MarcadorApi("https://productospy.org/api/vendors/") }


            private val loggingInterceptor = HttpLoggingInterceptor().apply {
                this.level = HttpLoggingInterceptor.Level.BODY
            }

            operator fun invoke(baseUrl: String): MarcadorApi {
                val client = OkHttpClient.Builder().apply {
                    /**addNetworkInterceptor(StethoInterceptor()) */
                    addNetworkInterceptor(loggingInterceptor)

                }.build()

                return Retrofit.Builder()
                    .client(client)
                    .baseUrl(baseUrl)
//                .addCallAdapterFactory(CoroutineCallAdapterFactory())
                    .addConverterFactory(GsonConverterFactory.create())
                    .build()
                    .create(MarcadorApi::class.java)
            }
        }




}