package com.example.pruebamaps.Menu

import android.content.Intent
import android.content.pm.PackageManager
import android.location.Location
import android.net.Uri
import android.os.Build
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.text.Editable
import android.text.TextWatcher
import android.widget.ArrayAdapter
import android.widget.ListView
import android.widget.Toast
import androidx.annotation.RequiresApi
import androidx.core.app.ActivityCompat
import com.example.pruebamaps.R
import com.google.android.gms.location.FusedLocationProviderClient
import com.google.android.gms.location.LocationServices

import com.google.android.gms.maps.CameraUpdateFactory
import com.google.android.gms.maps.GoogleMap
import com.google.android.gms.maps.OnMapReadyCallback
import com.google.android.gms.maps.SupportMapFragment
import com.google.android.gms.maps.model.BitmapDescriptorFactory
import com.google.android.gms.maps.model.LatLng
import com.google.android.gms.maps.model.Marker
import com.google.android.gms.maps.model.MarkerOptions
import com.google.android.material.bottomsheet.BottomSheetDialog
import com.mancj.materialsearchbar.MaterialSearchBar
import kotlinx.android.synthetic.main.activity_principal.*
import kotlinx.android.synthetic.main.fragment_info.*
import kotlinx.android.synthetic.main.fragment_info.view.*
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class Principal : AppCompatActivity(), OnMapReadyCallback, GoogleMap.OnMarkerClickListener {

    private lateinit var fusedLocationClient : FusedLocationProviderClient

    private lateinit var lastLocation : Location

    private var selectedMarker:Marker?=null



    companion object {
        private const val LOCATION_PERMISSION_REQUEST_CODE = 1
    }
    private val markerClickListener = object: GoogleMap.OnMarkerClickListener{
        override fun onMarkerClick(marker: Marker?):Boolean{
            if(marker == selectedMarker){
                selectedMarker=null
                return true
            }
            selectedMarker =marker
            return false
        }
    }

    override fun onMarkerClick(p0: Marker?) = false
    private lateinit var map: GoogleMap

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_principal)
        val mapFragment = supportFragmentManager
            .findFragmentById(R.id.map) as SupportMapFragment
        mapFragment.getMapAsync(this)




                            val lv = findViewById(R.id.listview) as ListView
                            val searchBar = findViewById(R.id.editText) as MaterialSearchBar
                            searchBar.setHint("Buscar Producto> ")
                            searchBar.setSpeechMode(true)
                            searchBar.addTextChangeListener(object : TextWatcher {
                                override fun beforeTextChanged(charSequence: CharSequence, i: Int, i1: Int, i2: Int) {

                                }

                                override fun onTextChanged(charSequence: CharSequence, i: Int, i1: Int, i2: Int) {
                                    //SEARCH FILTER
                                }

                                override fun afterTextChanged(editable: Editable) {

                                }
                            })



        fusedLocationClient = LocationServices.getFusedLocationProviderClient(this)

            txt_filtro.setOnClickListener {

                val dialog = BottomSheetDialog(this@Principal)
                val view = layoutInflater.inflate(R.layout.fragment_filtro, null)
                dialog.setContentView(view)
                dialog.show()

            }
            imgfav.setOnClickListener {
                val dialog = BottomSheetDialog(this@Principal)
                val view = layoutInflater.inflate(R.layout.fragment_fav,null)
                dialog.setContentView(view)
                dialog.show()
            }
            imginfo.setOnClickListener {

            val dialog = BottomSheetDialog(this@Principal)
            val view = layoutInflater.inflate(R.layout.fragment_info,null)
            dialog.setContentView(view)
            dialog.show()

            view.txt_terminos.setOnClickListener {
                val url = "https://productospy.org/disclaimer"
                val i = Intent(Intent.ACTION_VIEW)
                i.data = Uri.parse(url)
                startActivity(i)

            }
            view.txt_vendedor.setOnClickListener {
                val url = "https://productospy.org/vendor"
                val i = Intent(Intent.ACTION_VIEW)
                i.data = Uri.parse(url)
                startActivity(i)

            }
            view.txt_code.setOnClickListener {
                val url = "https://phoebe.roshka.com/gitlab/"
                val i = Intent(Intent.ACTION_VIEW)
                i.data = Uri.parse(url)
                startActivity(i)

            }

        }

    }

    override fun onMapReady(googleMap: GoogleMap) {
        map = googleMap

        map.setOnMarkerClickListener(this)

        setUpMap()

        MarcadorApi.stackClient.getMarker(15, 0).enqueue(
            object: Callback<Coordenadas> {
                override fun onFailure(call: Call<Coordenadas>, t: Throwable) {
                    t.printStackTrace()
                }

                @RequiresApi(Build.VERSION_CODES.O)
                override fun onResponse(call: Call<Coordenadas>, response: Response<Coordenadas>) {
                    if (response.isSuccessful) {
                        val mark = response.body()
                        val coor = mark!!.features

                        for( item in coor.indices ){
                            var pos =mark.features[item].geometry.coordinates
                            var nombre=mark.features[item].properties.nombre

                            map.addMarker(
                                MarkerOptions()
                                    .position(LatLng(pos[1],pos[0]))
                                    .title(nombre)
                                    .icon(BitmapDescriptorFactory.fromResource(R.drawable.imgmarkernormal)
                                    )
                            )

                            map.setOnMarkerClickListener { marker ->
                                var marcador = marker.position

                                true
                            }

                        }

                    }else{

                        Toast.makeText(this@Principal, "Error", Toast.LENGTH_SHORT).show()

                    }
                }
            }
        )
    }
    private fun setUpMap() {
        if(ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED){
            ActivityCompat.requestPermissions(this,
                arrayOf(android.Manifest.permission.ACCESS_FINE_LOCATION),LOCATION_PERMISSION_REQUEST_CODE)
            return
        }

        map.isMyLocationEnabled= true

        fusedLocationClient.lastLocation.addOnSuccessListener(this){ location ->

            if(location != null){

                lastLocation = location
                val currentLatLong = LatLng(location.latitude, location.longitude)
                map.moveCamera(CameraUpdateFactory.newLatLngZoom(currentLatLong, 18f))

            }
        }
    }
}
//TY4A.