package com.example.pruebamaps

import android.content.Context
import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.system.Os.close
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.LinearLayout
import androidx.core.content.ContextCompat
import androidx.core.view.get
import androidx.viewpager2.widget.ViewPager2
import com.example.pruebamaps.Menu.Principal
import com.example.pruebamaps.Slider.IntroSlide
import kotlinx.android.synthetic.main.activity_intro_slider.*
import kotlinx.android.synthetic.main.slide_item_container.*


class IntroSlider : AppCompatActivity() {
    private val SKIP = "PREFERENCE_NAME"
    private val IntroSliderAdapter = com.example.pruebamaps.Slider.IntroSliderAdapter(
        listOf(
            IntroSlide(
                "ENCUENTRA",
                "¿Tapabocas, alimentos, alementos de limpieza, alcohol en gel? PorductosPY facilita conectarte con los vendedores de los productos que necesitas!",
                 R.drawable.imgslider1
            ),
            IntroSlide(
                "OFRECE",
                "¿Estás vendiendo  algún producto, ofreciendo algún servicio y necesitas darte a conocer?",
                 R.drawable.imgslider2
            ),
            IntroSlide(
                "CONÉCTATE",
                "Encúentranos en FACEBOOK, TWITTER e INSTAGRAM como ProductosPY",
                 R.drawable.imgslider3

            )
        )
    )
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_intro_slider)
        val sharedPreference =  getSharedPreferences(SKIP,Context.MODE_PRIVATE)
        var editor = sharedPreference.edit()

        if (sharedPreference.getBoolean(SKIP, false)){
            goToLogin(this)
        }
        introSliderViewPager.adapter = IntroSliderAdapter
        setupIndicator()
        setCurrentIndicator(0)
        introSliderViewPager.registerOnPageChangeCallback(object :
            ViewPager2.OnPageChangeCallback() {
            override fun onPageSelected(position: Int) {
                super.onPageSelected(position)
                setCurrentIndicator(position)
            }

        })
        btn_empezar.setOnClickListener {
            editor.putBoolean(SKIP, true)
            editor.apply()
            goToLogin(this)
        }
    }
    private fun setupIndicator(){
        val indicators = arrayOfNulls<ImageView>(IntroSliderAdapter.itemCount)
        val layoutsParams : LinearLayout.LayoutParams =
            LinearLayout.LayoutParams(
                ViewGroup.LayoutParams.WRAP_CONTENT,
                ViewGroup.LayoutParams.WRAP_CONTENT
            )
        layoutsParams.setMargins(8,0, 8, 0)
        for (i in indicators.indices)
        {
            indicators[i] = ImageView(applicationContext)
            indicators[i].apply{
                this?.setImageDrawable(
                    ContextCompat.getDrawable(
                        applicationContext,
                        R.drawable.indicator_inactive
                    )
                )
                this?.layoutParams = layoutsParams
            }
            Indicadores.addView(indicators[i])
        }
    }
    private fun setCurrentIndicator(index: Int) {
        val childCount = Indicadores.childCount
        for (i in 0 until childCount) {
            val ImageView = Indicadores[i] as ImageView
            if (i==index) {
                ImageView.setImageDrawable(
                    ContextCompat.getDrawable(
                        applicationContext,
                        R.drawable.indicator_active
                    )
                )
            }else {
                ImageView.setImageDrawable(
                    ContextCompat.getDrawable(
                        applicationContext,
                        R.drawable.indicator_inactive
                    )
                )
            }


        }

    }
    private fun goToLogin(context : Context){
        val intent = Intent(this, Principal::class.java)
        startActivity(intent)

    }
    private fun close (){
        btn_empezar.visibility = View.VISIBLE
    }

}
